# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Private Classes

* `kubecm::deploy`: Puppet entrypoint for the kubecm::deploy plan

### Functions

#### Private Functions

* `kubecm::print_report`: Print apply results like a Puppet report

### Plans

* [`kubecm::deploy`](#kubecm--deploy): Install or upgrade a release

## Plans

### <a name="kubecm--deploy"></a>`kubecm::deploy`

Install or upgrade a release

#### Parameters

The following parameters are available in the `kubecm::deploy` plan:

* [`release`](#-kubecm--deploy--release)
* [`chart`](#-kubecm--deploy--chart)
* [`chart_source`](#-kubecm--deploy--chart_source)
* [`deploy`](#-kubecm--deploy--deploy)
* [`hooks`](#-kubecm--deploy--hooks)
* [`namespace`](#-kubecm--deploy--namespace)
* [`remove_resources`](#-kubecm--deploy--remove_resources)
* [`remove_patches`](#-kubecm--deploy--remove_patches)
* [`render_to`](#-kubecm--deploy--render_to)
* [`repo_url`](#-kubecm--deploy--repo_url)
* [`version`](#-kubecm--deploy--version)
* [`wait`](#-kubecm--deploy--wait)
* [`sleep`](#-kubecm--deploy--sleep)
* [`subcharts`](#-kubecm--deploy--subcharts)
* [`parent`](#-kubecm--deploy--parent)
* [`build_dir`](#-kubecm--deploy--build_dir)

##### <a name="-kubecm--deploy--release"></a>`release`

Data type: `String`

Installation name (what is this deployment called)

##### <a name="-kubecm--deploy--chart"></a>`chart`

Data type: `String`

Chart name, or your name for this deployment and set `chart_source`

Default value: `$release`

##### <a name="-kubecm--deploy--chart_source"></a>`chart_source`

Data type: `Optional[String]`

Typically `repo_name/chart_name` or an `oci://` URI, but could be a local path,
a valid Puppet file source, or `undef` for no chart (just Hiera resources).

Default value: `undef`

##### <a name="-kubecm--deploy--deploy"></a>`deploy`

Data type: `Boolean`

Run or skip the deployment

Default value: `true`

##### <a name="-kubecm--deploy--hooks"></a>`hooks`

Data type: `Boolean`

Enable or disable install hooks

Default value: `true`

##### <a name="-kubecm--deploy--namespace"></a>`namespace`

Data type: `Optional[String]`

Kubernetes namespace to manage

Default value: `undef`

##### <a name="-kubecm--deploy--remove_resources"></a>`remove_resources`

Data type: `Array[String]`

A list of keys to remove from the resources hash (i.e. don't deploy these!)

Default value: `[]`

##### <a name="-kubecm--deploy--remove_patches"></a>`remove_patches`

Data type: `Array[String]`

A list of keys to remove from the patches hash (i.e. don't apply these!)

Default value: `[]`

##### <a name="-kubecm--deploy--render_to"></a>`render_to`

Data type: `Optional[String]`

Just save the fully-rendered chart to this yaml file

Default value: `undef`

##### <a name="-kubecm--deploy--repo_url"></a>`repo_url`

Data type: `Optional[String]`

Optional URL of the Helm repo to add

Default value: `undef`

##### <a name="-kubecm--deploy--version"></a>`version`

Data type: `Optional[String]`

Optional Helm chart version

Default value: `undef`

##### <a name="-kubecm--deploy--wait"></a>`wait`

Data type: `Boolean`

Wait for resources to become available

Default value: `false`

##### <a name="-kubecm--deploy--sleep"></a>`sleep`

Data type: `Optional[Numeric]`

Wait additional time, in seconds (for example, for a VIP to propagate)

Default value: `undef`

##### <a name="-kubecm--deploy--subcharts"></a>`subcharts`

Data type: `Array[Hash]`

Additional charts to deploy as part of this one

Default value: `[]`

##### <a name="-kubecm--deploy--parent"></a>`parent`

Data type: `Optional[String]`

Private. The parent release this one is being rendered for.

Default value: `undef`

##### <a name="-kubecm--deploy--build_dir"></a>`build_dir`

Data type: `String`

Scratch directory for compiling manifests

Default value: `lookup('kubecm::deploy::build_dir')`

